; Muster Rekursion Listen V2.scm
; am Beispiel einer Rekursion über Listen mit mehr als einem Parameter

(define
  (rekursive-Fkt element liste)
  (cond
    ((null? liste)      ; Abbruchfall ->
     (wert-im-abbruchfall element liste)) ; Wert definieren durch Funktion!
    ; ggf weitere alternative (Bedingung Wert)
    (else
     (bearbeite
      element
      liste
      (rekursive-Fkt
       (update-1 element)
       (update-2 liste))         ; konkrete Bearbeitung & update aufrufen
      )
     )
    )
  )

; Die konkrete Problemloesung haengt von den aufgerufenen Funktionen
; Abbruch?, wert-im-abbruchfall, bearbeite, update-1 und update-2 ab
; Beispiel Anhaengen eines neuen Elements an eine Liste
(define
  (Abbruch? element liste)
  (null? liste)                       ; typische Abbruchbedingung
  )
(define
  (wert-im-abbruchfall element liste)
  (list element))                      ; benoetigt hier liste nicht
(define
  (bearbeite element liste rekursionswert)
  (cons (first liste) rekursionswert)) ; benoetigt hier element nicht
; und der update-Funktionen ab.
(define
  (update-1 element)
  element)                             ; keine Aenderung von element
(define
  (update-2 liste)
  (rest liste)                         ; liste wird abgebaut
  )


(rekursive-Fkt 'f '(a b c d e))