; Muster Rekursion Listen.scm
; am Beispiel einer Rekursion über Listen

(define
  (rekursive-Fkt liste)
  (cond
    ((Abbruch? liste)      ; Abbruchfall ->
     (wert-im-abbruchfall liste)) ; Wert definieren durch Funktion!
    ; ggf weitere alternative (Bedingung Wert)
    (else
     (bearbeite
      liste
      (rekursive-Fkt
       (update liste))         ; konkrete Bearbeitung & update aufrufen
      )
     )
    )
  )

; Die konkrete Problemloesung haengt von den aufgerufenen Funktionen
; Abbruch?, wert-im-abbruchfall, bearbeite und update ab
; Beispiel Laenge einer Liste
(define
  (Abbruch? liste)
  (null? liste)                       ; typische Abbruchbedingung
  )
(define
  (wert-im-abbruchfall liste)
  0)                     ; benoetigt hier liste nicht
(define
  (bearbeite liste rekursionswert)
  (+ 1 rekursionswert)) ; benoetigt hier element nicht
(define
  (update liste)
  (rest liste)                         ; liste wird abgebaut
  )


(rekursive-Fkt '(a b c d e))